// execution control commands

#define for              2 // loop on index (register) for "range"
#define continue         3 // continue([loop_register]);  //continue loop
//if your loop is like: i=for(0>9) use  continue(i) ,otherwise engine may not work propely for nested loops;
#define goto             4 // go to label  e.g: goto(MYLABEL);
#define if               5 // compare two values e.g if(i>(var.2))
#define else             6 // do if not
#define doWhen           7 // do when an event (OPEN,CLICK,POLL...)
#define quit             8 // quit the execution of this descriptor
#define break            9 // break([loop_register]) break from this "for" loop, continue in next level
//if your loop is like: i=for(0>9) use  break(i), otherwise engine may not work propely for nested loops;

#define close           10 // close[(return_int_value)|CLOSETABSHEET]  close this window and/or descriptor, pass the return code to the parent (if any)
//1. remember allways to issue "close" to free the memory, it is most important for windowless descriptors;
//2. "close" with parameter like close(0) ensures that the execution continues in the parent descriptor (if any) 
//   after corresponding open(...) command, NO MATTER if open looks like "reg=open(..)" or like "open(..)"
//3. One exception: this command is ignored for the descriptors which create "tabbed dialogs" (creators) (usually these "creators" are windowless)
//   the creators are "closed" by user action when user closes the whole "tabbed" dialogs frame window.
//4. In the past, this command used to be ignored when the calling descriptor was inside "POLL" event, not any more.
//5. If this command is issued inside TAB descriptor with the parameter CLOSETABSHEET , like close(CLOSETABSHEET) , the whole TABSHEET with all the TABS will be closed

#define open            11 // [reg=]open(desc(params) [DIALOGNAME[:tabshandlereg]  [menu] [NOPARENT[,NoParentParameterString]]] [CONTINUENOW]) //popup another window and execute the descriptor
//e.g: "open(@local\mydesc(par1,par2) DLG_MYDESC"  or for windowless "open(@local\mydesc(par1,par2)"
//execution after "open" continues ONLY AFTER child descriptor (mydesc) issues close with parameter, like close(0),NO MATTER if open looks
//like "reg=open(..)" or like "open(..)"
//NOPARENT is used to allow "parent" window (the one which issues open(..)) to be closed without closing "child" window.
//If NOPARENT used: 
//  1. it is not allowed to pass parameter vars (you can still pass integer parameters like constant number , to be accepted as registers in the child)
//  2. The execution control will NEVER be returned after open(..) command in the calling descriptor
//     That is why never use "open(... NOPARENT) in windowless descriptors, because if the control never returned, who will close the windowless descriptor?
//Exceptions: the execution after "open" continues immedeately , if ":tabshandlereg" used , see "tabbed dialogs below". Also when CONTINUENOW used, see below
//tabshandlereg is a register which returns handle to the tabs/propertysheet.
//if tabshandlereg==0, it means the  FIRST Tabed Dialog and the whole TabbedSheet must be created, otherwise NEXT tabbed dialog is created and attached
//to the tabbed sheet. Also for open which creates "tabbed dialogs",the execution continues after "open" immedeately, no matter what.
//NoParentParameterString - variable which contains paramer: sometimes you need to pass parameter string even to NOPARENT window.  You receive it in doWhen(OPEN) via sysWinParameter
//CONTINUENOW - sometimes we do not want to wait until child descriptor ends and return control to parent, OR continue after call with NOPARENT. Use CONTINUENOW for this.
//it is much safer to use CONTINUENOW with association with NOPARENT. Otherwise child returns control to parent twice.
#define return          12 //return from subroutine which was entered via "call". Returns to the next method after the "call". 

// general commands

#define send            13 //[resulvar=]send(OPERATION WHATTOSEND [INDEXES [VALUES]] [goto:ENDOFTABLABEL]); 
//OPERATION=GET|SET|NEXT|SQUE|GQUE|GQNE|SQNE
// GQUE and SQUE-> add to GET/SET queue, if var with the same OID and indices exist replace it
// GQNE and SQNE-> add to GET/SET queue, but do not check if var with the same OID and indices exist
//for GET,SET - the "true" block after send statement means processing possible SNMP error
//WHATTOSEND=MibObject(s) or ITEMS
//INDEXES=i1,i2,i3 - subparameters divided by commas  - maybe absent if they are defined by "WHATTOSEND"
//VALUES - values for set, maybe absent if they are defined "WHATTOSEND"
//goto:ENDOFTABLABEL for SNMP-NEXT only - where to go when ENDOFTABLE situation happens
			   
#define call            14 // call descriptor internal  subroutine: jump to internal label and return to the "calling point" subroutine executed
// e.g,: "call(MYSUBROUTINE);" Important: the subroutine must issue "return" in order to "return" to the calling point.

#define showControls    15 // showControls(SHOW|HIDE|ENABLE|DISABLE RangeOfItems|RangeOfControlDs);
//Whole RangeOfControlDs maybe in a text var. Independent range members maybe in vars/regs
#define setTitle        17 //setTitle(titlestring [tabbmp]);// put string in window's dash-bar, if tabbmp exists, it is bmp for tabbed dialog
#define showHelp        18 // show help item (from help file)

#define findEmptyLine   19 // for marked index, find the first empty line
#define isLineSelected  20

// SET commands

#define putInQueue       21 //put "set" request in "set" queue// DO NOT USE! bad practice Depricated
#define sendQueue        22 //sendQueue([SETLeave]); 
//sends SET requests which are acummulated in  "set" queue (they were accumulated either by send(SQUE|SQNE... or by putInQueue
//if SETLeave is indicated, does not wait for the response)
//the "true" block after sendQueue statement means processing possible SNMP error ("true" block does not apply when SETLeave is used)
#define clearQueue       23 //clear "set" queue
#define checkErrors      24

// messages commands

#define showError        25 // showError([STOP_ON_LOCAL_SERVER] errormessage); 
#define getConfirm       26
#define showMessage      27 // showMessage([STOP_ON_LOCAL_SERVER] infomessage @title);
//e.g showMessage("Device \myname is not found on any map" @Error!); //@Error is title

// list-box commands

#define showListBox      28
#define clearListBox     29
#define selectLine       30
#define deleteLine       31
#define replaceLBString  32
#define findLBString     33
#define selectLastLine   34
#define getLBString      35
#define selectAllLines   36
#define getSelLines      37 // Integration - fix26  (it was isLineSelected)


// child descriptor commands

#define doInParentWindow 38
#define copyFromParent   39
#define copyToParent     40

#define varsFile         41 //varsFile(var1,var2,var3... {LOAD|SAVE} filepath} //old shareWithParentO - obsolete
//returns false if some problem occures (no file for LOAD, etc...)
//example varsFile(enterprise,varfsps,varports LOAD "@data\\\DeviceName\\devinfo.sav");
//        varsFile(enterprise,varfsps,varports SAVE "@data\\\DeviceName\\devinfo.sav");

#define getListBox       42
#define saveListBox      43

// device and cards commands

#define openCard         44
#define replaceCards     45 //replaceCards(cardsvar [startslot# [endslot#]]) //e.g replaceCards(cards 1 16);
#define forCards         46
#define showLeds         47
#define setSubDevice     48
#define setChildDevice   49

// data commands

#define getDeviceParam   50 //getDeviceParam(param-name parvaluevar [INTEGER|STR|BYTES|FLOAT|RUNTIME]);
#define setDeviceParam   51 //setDeviceParam(parname [parvalue|DELETE] [INTEGER|STR|BYTES|FLOAT|RUNTIME] [NoSave]);
//It is strongly reccomended to use STR type only. Other types are depricated.
// for DELETE if parname ends with * , delete all with the corresponding prefix
// example: setAppParam("MYFEATURE*" DELETE RUNTIME);
//1. NoSave does not make sense when RUNTIME used , becaues RUNTIME is a different array in the memory
//   so RUNTIME and NoSave are mutually exclusive
//2. RUNTIME creates/changes a parameter that exists only in volatile memory
//3. NoSave creates/changes this parameter in the in the cached image of the persistent file
// (devicename.dev in @data directory) and will be written to the file with the next persistent setDeviceParam call.
//Using getDeviceParam/setDeviceParam with "RUNTIME" means completely different array in memory than when
//it is used without RUNTIME


// bitmaps commands
#define setBitmap        52 //setBitmap(/id[,BUTTON_CELL] bitmap [leds [FAST [ledNo]]])
//optional BUTTON_CELL parameter makes it look like a button: setBitmap(/15,BUTTON_CELL BMP_MYBUTTONBMP);
#define setCardBmp       53
#define loadListBox      54
#define initCombo        55

// debug commands

#define setDebugFlag     56
#define resetLogFile     57                     
#define isSimulation     58

// "var" indexes commands

#define changeIndex      59
#define getIndex         60
#define getIndexes       61 //^var1=getIndexes(^var2 [VARARRAY]) //when VARARRAY: gets indicies as array of vars var.0,var.1,...

// other commands

#define findFile         62
#define findNumber       63 //findNumber(number/index range-of-numbers [INDEX]); //range may be in the text var
#define showCommIcons    64
#define pollCard         65
#define setVersion       66
#define invalidComm      67
#define forceInit        68
#define copyDir          69 //copyDir(sourcedir targetdir [OVERWRITE|NOTOVERWRITE [excludepatterns]]);//copies recursievly all the underlying files/dirs, returns false if fails , 
//if targetdir does not exist it will be created; sourcedir,targetdir may end with slash or not - your choice
//if a copied file exists, it will be overwritten only if OVERWRITE is indicated
//excludepatterns can look like this "*\\mibs\\*,*.txt,*.all"  divided by comma
//default is NOTOVERWRITE - when there is just two parameters

// internal commands

#define debug1           70
#define debug2           71

#define addNewDevice     72 //addNewDevice(devtypestring), e.g. addNewDevice("NC316tring), opens describe
#define openApp          73
#define closeApp         74
#define changePassword   75
#define userType         76 //used by system only, for app purposes please use UserType from defines.h

// string commands

#define setChars          77 //setChars({UP|LOW|char_value} ^var {start_index[,end_index]|ALL});
//the input var can be TEXT, OCTETSTR, MACAddr, IPAddr
//e.g:  setChars(LOW x1.0 ALL);// convert x1 to lower case string //setChars(UP x1.0 ALL);// convert x1 to upper case string
//e.g:  setChars(0 x1.0 ALL); - zero all the byte for the lenghth whatever it is 
//e.g:  setChars(0 x1.0 0,511);//zero 512 bytes , if the length was less, set the lenghth to 512 (maximum)
//e.g:  setChars('a' x1.0 0,9);//first 10 bytes are set to the hex value of 'a'. if the length
//setChars(' ' var.0 0,20) - does not work; use setChars(0x20 var.0 0,20); 0x20 - is ASCII code for space
#define convertUpTime     78 //convertUpTime(^var); Input parameter is var - NUMBER=time in hundreds of sec. output is the same var, but now TEXT like
//like "3 months, 5 days 3 hours" //example: convertUpTime(mytime.3)
#define changeWord        79

#define getYesNo          80
#define selectDevice      81 //selectDevice(device#|device_name|deviceIP [DeviceStringType|Any [GoThere]])  ; selectDevice(-1) - make window deviceless
// selectDevice(-2) - set dummyOne as current device, used to make send(GET/SET [localmibobject] ..) work in deviceless windows

#define getRootDir        82 //getRootDir([NO]); //if there is parameter NO , the result is without last dir delimeter: "c:\\megaweb\\" vs, "c:\\megaweb"
#define selectLineMLB     83
#define selectCard        84
#define initVar           85 //var=initVar(anothervar|reg|constant); //if var was initialized before does not do anything. However if it was not initialized it will be 
//initialized to the value of the parameter. Returns "true" if var was initialized. Returns "false" if var was NOT initialized. initVar can be used with or without
//conditional blocks. for example:
//1. parservname.0=initVar(""); //init parservname.0 to "" if it was not initialized before
//2.  myvar.0=initVar(0);//init myvar.0 to 0 if it was not initialized before
//3.  myvar.0=initVar(anothervar.2);//init myvar.0 to the value of anothervar.2,  if myvar.0 was not initialized before
#define getNLines         86

#define saveItems         87
#define loadItems         88

#define getWord           89  // var=getWord(i string|var|item [delimiter]) ; opposite operation is reg=getMenuNumber(item string)

#define compare           90 //depricated has some bugs, use compareStringTo instead
#define getDeviceType     91 //getDeviceType([{devtype_index} | {devclass_index devtype_index_in_class}])
//returns device type number from devices.all. If no parameters used, the current device type number is returned
//devtype_index starts from 1:  1,2,3.....
//devclass_index starts from 0: 0,1,2....    sevtype_index_in_class starts from 0: 0,1,2.....
#define findMarkedIndex   92

#define sendClick         93 //sendClick(control_id [win_descriptor_name|PARENT|BROTHERS[,clickparstring] [NOW|LOCALONLY] [SAMEDEVONLY]]);e.q sendClick(123 "alarmlog" NOW)  or sendClick(123)
//NOW          means: do not put in queue, send NOW. Do not use NOW if you do not really need it.
//SAMEDEVONLY  means: send only to to those windows which are running 'win_descriptor_name' for the SAME device as the window-sender
//LOCALONLY    means: send only to to those windows which are in the same PHYSICAL MONITOR/COMPUTER as the window-sender. Note  that "LOCAL" here does NOT mean local server  GUI only 
//Generally speaking, sending clicks to windowless descriptors does not work in Web mode, however sometimes it still may be required to send click to a
//windowless descriptor. If you REALLY need it, use fictive control_id which more or equal 32760 (>=32760)
//example: sendClick(99995 PARENT);
//BROTHERTAB  means send event only to windows which are BROTHERS , used mostly for TAB-BROTHERS
#define sendDClick        94 //sendDClick(controlid);

#define debugMsg          95 //debugMsg(string|var|item|reg|system_constant);//string can embed other things (vars, regs, etc...)

#define alarmMsg          96 //alarmMsg(severity [\"message\"])  // can be called without message just to paint current device icon
//severity: 0=CRITICAL,red;1=WARNING,yellow;2=INFORMATIONAL,purple;3=NORMAL,green1;4=UNKNOWN,LGRAY
//          5=NONE,GRAY;6=GRAY;7=BROWN;8=BLACK;9=LBLUE,10=MARGINAL,ORANGE1;11=GRBLUE;
//if called without message, just paints the device icon

#define deviceAddress     97
#define isFileExist       98 //isFileExist(name) ; e.g isFileExist(var) ;isFileExist("c:\\autoexec.bat"); isFileExist("@local\\local.dll");

#define isBit             99 //  isBit(^var bitNumber);//bitNumber=0,1,2...
#define setBit            100 //setBit(^var bitNumber 0|1);//bitNumber=0,1,2...
#define subStr            101   //var1=subStr(var2 offset [NumberOfBytes] [int])

#define sqlSetOwnConnect  102  //former getVarType - took out nobody uses ;reserved
#define getVarLength      103  //reg=getVarLength(var)
#define setWindowWidth    104
#define setWindowHeight   105
#define closeChildren     106
#define discover_start    107
#define discover_end      108
#define getDiscPars       109
#define runApp            110 //[reg=]runApp(commandlineVAR [THREAD|WAIT|SHELL [SHOW|HIDE|MINIMIZED]])
//runs application: commandlineVAR contains command string);
//WAIT: descriptor waits untill the app finishes ; SHOW|HIDE|MINIMIZED - how to show app main window (sometimes it is good to hide DOS-program window);
#define isOctStrCorrect   111 // isOctStrCorrect(var minlen maxlen [Ignore]); //checks syntax of octet string text representation, 
//e.g:  "0FAB129E" - returns true;  "0FAB12VE" returns false
//      "0fab129e" returns true, only if "Ignore" option is used (which means "ignore case" for abcdef/ABCDEF)
#define addLink           112 //addLink(linkpars [NoSave]); Color=linkpars.3;  Width=linkpars.4;
//.9=mapname (optional), linkpars.10=Link Status (optional) linkpars.11=Service(s) (optional)
//this will modufy link if it exists for dev1name (linkpars.1),dev2name (linkpars.2),if1name (linkpars.7), if2name (linkpars.8)
//linkservices(comma separated,every service name no longer than 16 symbols)  linkpars.12=donotchangecolor=0|1 (optional)
//linkpars.13=userfield (optional) linkpars.14=notepad (optional)
#define delLink           113 //delLink([linkpars]); without linkpars current selected link is deleted, otherwise link is defined by:
//dev1name (linkpars.1),dev2name (linkpars.2),if1name (linkpars.7), if2name (linkpars.8)
#define getLinkPars       114 //getLinkPars(linkpars [BYPARAM]) //.9=mapname
//without BYPARAM current selected link is returned, otherwise the link is found by parameters:
//dev1name (linkpars.1),dev2name (linkpars.2),if1name (linkpars.7), if2name (linkpars.8), map_name linkpars.9
//linkpars.10=status string; linkpars.11=service(s) comma separated; linkpars.12=donotchangecolor=0|1 
//linkpars.13=userfield linkpars.14=notepad 
#define getDevTypeName    115 //getDeviceName1 : varname=getDevTypeName(i[,j] [WITHPARENTS]);//returns varname.0=devtype name, varname.1=devtype comment , varname.2=devtype_class;
//if first parameter is only 'i', i - means device type index (starts from 1: 1,2,3....) ; 
//if there is i,j : i=devclass index (0,1,2..), j=devtype_index_in class (0,1,2,...)
#define setCurDev         116 //setCurDev(devname [MAP_NAME])");
#define setCurrDevNumb    117 //setCurrDevNumb(number [NOSELECT|GOTHERE]);//number=1,2,3...; use NOSELECT to set current for the window only (not map)
#define cvtexIPtoOct      118
#define addMap            119 //addMap(mapline); mapline.0=mapname of the new map; mapline.1=0; it returns the index of the 
//newly added  map (0,1,2,3....) or index of the "old" map if the map with such name (mapline.0) already existed
#define deleteMap         120
#define openMap           121
#define getMap            122
#define closeMap          123
#define isFileNameCorrect 124
#define addParDevice      125 //addParDevice(devpars);
//devpars.0 - int type of the device
//devpars.1 - name of the Device
//devpars.2 - string IP Address
//devpars.3 - get-community
//devpars.4 - set-community
//devpars.5 - "HIDE" (optional virtual)
//devpars.6 - "IPINIQUE" (optional: add only if no such IP)
//devpars.7 - "INITASREADY" (optional: initasready)
//devpars.8 - Notepad (optional) 
//devpars.9 - mapname (optional)
//devpar.10 - =0|1 persist flag default is 0; if this flag is 1, Hidden device is restored after Enengine restart
//in the past it was only "HIDE" (virtual) devices. Default is 1, but it is better to have 0 to save disc work for many virt devices, like services
#define setBackImage      126
#define getDeviceData     127 //getDeviceData(linedev);//fill the vars (0-9) you want to receive
//returns: (note that you have to initialize the fields BEFORE getDeviceData , but only those fields you
//want to check AFTER getDeviceData
//linedev.0 -DeviceName
//linedev.1 -NotePad
//linedev.2 -SNMP Get Community
//linedev.3 -SNMP Set community
//linedev.4 -addFlag to return
//linedev.5 -n_interfaces in Describe, maybe absent
//linedev.6 -no_snmp_polling (0,1) maybe absent
//linedev.7 -tcpip_poll_flag (0,1) maybe absent
//linedev.8 
//linedev.9 mapname (optional)
//devpar.10 //NOT RETURNED - =0|1 persist flag for "HIDE" device, default is 0; if this flag is 1, Hidden device is restored after Enengine restart
#define setDeviceData     128 //setDeviceData(linedev); //also saves to *.dev file ;the same params as addParDevice (without .10)
#define getInterfaceData  129 //getInterfaceData(lineif); 0=IPAddr(text),1-ifType=2(IP) ,2-pollint,3-timeout,4-retries,5-intf number(def=1)
#define setInterfaceData  130 //setInterfaceData(lineif); //does not save to *.dev file , use setDeviceData to save to file
#define describeCancel    131
#define describeOK        132
#define initDevicesCombo  133
#define getComboNumber    134
#define setComboNumber    135 //setComboNumber(item|/id var/numb/reg [STRING])");//number is index 0,1,2,...
#define openDeviceWindow  136 //openDeviceWindow() //opens main (front panel) current device window
#define setToolTip        137 //setToolTip([/]id text [ [led#|treenodehandle|pictureElementIndex] | [tableline tablecell] ]  )
//note, now setToolTip can be used to set a tooltip to certain led of a slot OR for certain cell of a table.
#define wait              138 //wait(sec) - depricated - use pauseExecution(sec) instead
#define editFile          139
#define getOpenFileName	  140 //parvalue=getOpenFileName(root filter1,filter2... [DIRECTORY]) e.g parvalue=getOpenFileName(@ All,*.*);
//returns 'false', if user cancels the standard "OpenFile" dialog
#define parse2words       141 //words=parse2words(sourcestring ',' [n_words]);//to use space as delimeter use - (dash) without single quotes
#define getNVars          142 //reg=getNVars(var) ; returns number of vars in Var Array, see also trimVarArray
#define getStrLength      143
//getMenuNumber(item string) ; returns index (starts from 0) in the menu, which is defined by item
//returns reg>=item->first - index and true if found; otherwise return reg=-1 and returns false
#define getMenuNumber     144 //reg=getMenuNumber(item string) ; //operation is opposite to getWord
#define saveVars          145 //saveVars(vars [name.ext] [mode] [title] [LETOTHERSWORK]) //it is better to use varsFile command instead
#define loadVars          146 //reg=loadVars(var name.ext [title] [LETOTHERSWORK]) //it is better to use varsFile command instead
#define getDevicePath     147
#define copyFiles         148
#define addLBString       149
#define getText           150 //var=getText(/control_id);
#define str2var           151 //var=str2var(item string ['sep']);
#define getItemAttr       152
#define getParams         153
#define changeChars	      154
#define deleteFile	      155// deleteFile(filepathstring); returns true on success; false otherwise
//Examples: deleteFile("@data\\mydir\\myfile.txt"); deleteFile("c:\\myoutsidedir\\myfile.txt"); //Note that you do not have to worry about Linux/Unix dir delimeter here
#define var2str		      156 // str=var2str(item var ['sep']);
#define getFileName	      157 //varname=getFileName(long_name.0);//returns: varname.0=short_file_name_WITHOUT_extension; varname.1=extension
//varname.2=full path with correct dir delimeter per platform requirements. The input can start with "@" (if under MV directory) or NOT
//Note that you do not have to worry about Linux/Unix dir delimeter here 
#define getTrapVars	      158 //var=getTrapVars(1|2|3|4|5|6|7|8); //used in the traps/alarms callback descriptors
//1=traps VarBind, 2=trap# from MIB and *.alr file, 3= log string after inserstion of the parameters.
//4=severity1 : the alarm severity as it is defined by the user, 5= severity2 : the message severity 
//(depends on the alarm_severity and the value if it has a value, 6=iptext of the source device,
//7=alarm_index from *.alr file;  8-Text sender IP Address , but from pdu (v1 only, may not work)
#define setTrapVars	      159 //setTrapVars(3|4|5|6 var);//the meaning of numbers in the first parameter the same as in getTrapVars
//setTrapVars can be used in trap/alarm callback descriptor to modify final alarm severity using the trap/alarm payload (i.e. vars)
#define findDeviceByParam 160 //finds device(s) by a parameter name and/or value  former findFirstGap
//[devnames=]findDeviceByParam(parname[,RUNTIME] parvalue [SELECT]);
//returns "true" if at least one device found, otherwise returns "false"
//if SELECT is indicated, stops after the first found device and selects it.
//parname and/or parvalue may end with '*' meaning: use wildcard for comparison
//if RUNTIME indicated, searches in RUNTIME parameters, otherwise searches in regular device parameters
//if 'into' var is indicated, returns found devices names in the var array. The dimension of the array is the number of the devices found.

#define executeProgram    161

#define setControlColor   162 //setControlColor(RangeOfIds COL1 COL2 COL3 [PLAIN|BOLD|ITALIC|BOLD+ITALIC[,FontPlusPixels]]);
#define closeAll          163
#define findChars         164 //var=findChars(string chars ['replace-char']);
//e.g: linkpars.0=findChars(linkpars.0  " "  '_'); // To change every 'blank' symbol in the NAME on the '_' symbol
//myvar.0=findChars(myvar.0 "%*!-=><" '~'); // Replace  chars %*!-=><   with '~'
//temp.0=findChars(line.2 "~");//reurns true if line.2 contains ~
//{
// showError("Cannot contain '~');
// quit;
//}
#define convertTime       165 //var=convertTime(timeAsNumberOfSec [FULL]);
//returns time in TEXT format "DDD MMM dd hh:mm:ss YYYY";//year returned only when FULL is used

#define findDeviceIP      166 // name_var=findDeviceIP(ip_var[,TEXT] [[comm_reg] SELECT])
//returns true if the device is found , false if not found,  also device name is returned in name_var 
//comm_status_reg returns commOK for the device defined by ip_var, see definition of commOK in defines.h
//note  also that by default ip_var is of type IPADDR which is binary, not text. 
//if you want TEXT than use ip_var,TEXT (of course ip_var shoulld contain IP Address as TEXT)
//if the the 3rd parameter SELECT the device found becomes current in this window (like in selectDevice)


#define bringToTop        167 //bringToTop() -uncovers current window.
#define setDevWinDialog   168 //setDevWinDialog(dialogresname [REOPEN]); //dynamicaly changes Device Window dialog
#define deleteRequests    169 //deletes all the pending requests in the quueue for the current window.
#define resolveIP         170 //Integration - evfix11

#define sortVarArray      171 // former addDevice which is depricated and disabled NEVER USE!!!! evfix2530 Integration - fix32
//sortVarArray(vararray INCR|DECR [startkeyoffset [n_keychars]]);
//sorts VarArray which consists of strings . The sorting key is a substring inside strings. startkeyoffset && n_keychars define this substring
//startkeyoffset=0 if not indicated. If n_keychars is not indicated assuming n_keychars=number of symbols from startoffset till the end of the string
#define changeDevice      172 // changeDevice(varnewname [varnewtype [REOPEN]]);// evfix1347 Integration - fix32
#define removeAllDevices  173 // Integration - fix32

#define checkTCPIP        174 //Integration -evfix11
#define checkTCPIPdev     175 //Integration -evfix11
#define resolveIPname     176 //Integration -evfix11
#define changeDeviceType  177 //Integration -evfix11
#define stopTCPIPblocking 178 //integration -evfix11

#define addRtrtabline     179 //evfix11
#define getRtrtabline     180 //evfix11
#define checkSubnets      181 //evfix11

#define setVirtualDevices 182 
#define changeSlotSize    183 // - sides : 0=left, 1=right, 2=up, 3=down
#define setText           184 //setText(/id sometextvarOrconstant); //set a text to id#

#define cvOctIPtoText     185
#define deleteDevice      186 //deleteDevice(name [FAST]);
#define isSubStr          187 ////[reg=]isSubStr(sourcestring searchsubstring [startoffset]);//evfix1218 returns fals if not dound (reg=-1|0,1,2...) offset
#define changeSlotPos     188 //changes size and position of control in dialog
#define getComboString    189 //getComboString(item|/id var)
#define addComboString    190 //addComboString(item|/id var|string [n_strings]) (if n_strings inits combo)
#define setWindowSize     191 // edfix3
#define ftpOperation      192 //retcode=ftpOperation(ServerIP UserName Password {localFilename|"DELOLDERTHAN=n_days[,FNAMESTARTSFROM]"} remotedir {GETFILE|PUTFILE|DELFILE} [port [SECURE]]);
//returns retcode!=0 if success; retcode=0 if fails. 
//remotedir maybe: absolute path,relative(to ftp root) path on remote server (like 'mydir/myfile.txt"), or "." or "")
//localFilename maybe absolute path or path with @ , like "@data\\os900\\myfile.txt"
//The last question is: what will be the remote file name? It is derived as short file name from localFilename. So 
//if localfilename="@data\\os900\\myfile.txt" , remote file is "myfile.txt" 
//For DELFILE operation if localFilename="DELOLDERTHAN=30" - deletes all file on the remote server which are older than 30 days
//FNAMESTARTSFROM - optional prefix for the files to be deleted (will delete only files with names starting from the prefix)
#define getFileLine       193 //[var=]getFileLine(varFilePath [READ|READBIN,len|CLOSE] [reg_handle]]);
//Example1: Use when you need to read only ONE TEXT file AT a time per descriptor
//var=getFileLine("@data\\myfile.txt"); //open text file and read first line to var
//var=getFileLine("@data\\myfile.txt"); //read second line; if the file has only two lines this will also close the file
//getFileLine("@data\\myfile.txt" CLOSE);//CLOSE this file, if it has not been closed before, otherwise do nothing
//Example2: Use when you need to read only ONE BINARY file AT a time per descriptor
//var=getFileLine("@data\\myfile.bin" READBIN,20); //open binary file and read first 20 bytes to var
//var=getFileLine("@data\\myfile.bin" READBIN,30); //read next 30 bytes to var; if the file has less than 50 bytes this will also close the file
//getFileLine("@data\\myfile.bin" CLOSE);//CLOSE this file, if it has not been closed before, otherwise do nothing
//Example3: Use when you need to read more than ONE TEXT file AT a time per descriptor or pass file handle to another descriptor
//var=getFileLine("@data\\myfile.txt" READ reghandle); //open text file and read first line to var, keep handle in reghandle
//var=getFileLine("@data\\myfile.txt" READ reghandle); //read second line; if the file has only two lines this will also close the file
//getFileLine("@data\\myfile.txt" CLOSE reghandle);//CLOSE file defined by regahandle, if it has not been closed before (reghandle!=0), otherwise do nothing
//Example4: Use when you need to read more than ONE Binary file AT a time per descriptor or pass file handle to another descriptor
//var=getFileLine("@data\\myfile.txt" READBIN,20 reghandle); //open binary file and read first 20 bytes to var, keep handle in reghandle
//var=getFileLine("@data\\myfile.txt" READBIN,30 reghandle); //read next 30 bytes; if the file has less than 50 bytes, this will also close the file and set reghandle=0
//getFileLine("@data\\myfile.txt" CLOSE reghandle);//CLOSE file defined by regahandle, if it has not been closed before (reghandle!=0), otherwise do nothing
#define arpGetMac         194 //edfix6
#define arpGetMacRes      195 //edfix6
#define getQueue          196 //var=getQueue([chunksize]); //send requests from "get" queue (in "chunks", if there is second parameter)
//the "true" block after getQueue statement means processing possible SNMP error
#define clearGetQueue     197 //clear whatever is in "get" queue
#define isBridgeCorrect   198 //evfix76
#define setHTTPport       199 //evfix82
#define getHTTPport       200 //evfix82
#define getSMTPconfig     201 //evfix92
#define setSMTPconfig     202 //evfix92
#define sendEmail         203 // sendEmail(message[,subject] [e-mail address]);//if message ends with "\n&", it does not send, just puts in buffer_file
// "e-mail address"  is actually a string with comma-separeted e-mail addresses (no spaces) /
#define sendAlarm         204 //sendAlarm([ALARM#=]i_alarm spec var1 var2 var3 ...);
//spec=0|1 -generic|specific ; "ALARM#=" is used when i_alarm represents alarm index, not trap#
#define getService        205 //getServices(ind line [GLOBAL]); //evfix1105
//input: ind=0,1,2...
//output: line.0 -StrServiceName;line.1 -IntStatus=0-down,1-up,2-unknown(if GLOBAL line.1=port) 
//        line.2 -Int: Service Resp time (ms) ;line.3 -port ; line.4=Udpflag -Tcp=0;UDP=1;
#define sendTCPIPBlocking 206 //evfix148
#define writeToDeviceLog  207 //evfix166
#define checkTCPIPport    208 //evfix175
#define sendUDPRequest    209 //[^var1=]sendUDPRequest(dstprt[,srcprt] ^var2 [timeout [IPAddress]])//sendsUDPRequests and receives response
//^var2 contains request, ^var1 returns response if needed
//if IPAddress is not set the current device IP Address is used
//if timeout  is not set the current device/interface timeout is used
//if you do not want response, do not use ^var1 and/or set timeout=0;
//current limitation: only 512 bytes max in request and response (per one var only for request/response)

#define sendTrap          210 //sendTrap(TrapNumber IPAddressString var1 var2 var3 .....); //sends specific trap (not generic)
#define findDeviceType    211 //findDeviceType(varOID | varTypeName) finds Device Type by EnterpriseOid(var of OID type) or DevTypeName(var of text type)
#define getSNMPAgentConfig 212 //evfix219
#define setSNMPAgentConfig 213 //evfix219
#define getCardTypeInfo    214 //evfix220 
#define sqlExec            215 //sqlExec(RequestString [LETOTHERSWORK])");//returns false in case of mistake //if RequestString ends with "\n&", it does not perform the request, just puts in buffer
#define sqlResults         216 //sqlResults([LETOTHERSWORK])
#define makeDateTime       217 //^var/reg=makeDateTime(Month Day Year Hour Min Sec)  ;//Month=[0,11] ; Day=[1,31] ;
//Year=(101,102,103...)=(2001,2002,...years since 1900) Hour=[0,23] Min=[0,59] Sec=[0,59];
#define sqlEnd             218 //evfix250
#define sendTCPRequest     219 //responsevar=sendTCPRequest(port requestVar [timeout [ipaddresstext]]);
#define closeTCPconnection 220 //evfix300
#define setVarLength       221 //evfix300  setVarLength(length ^var)
//also in cases when the new length is bigger than the old length setVarLength will fill the rest with spaces for text vars and with 0x00 for OctetStrings
#define getLinkByIndex     222 //evfix306
#define compileMib         223 //[ntrapsreg=]compileMib(MibFilePath [spec [ADDMIB]])
#define typeCast           224 //^var1=typeCast(^var2 TEXT|NUMBER|NUMBER64|FLOAT|IPADDR|OCTETSTR|MACADDR);
#define setPollingDesc     225 //internal: - do not use - sets Device optional polling descriptor
#define packIntoVar        226 //packIntoVar(toVar offset fromVar [len]);//len is for text  or OctetStr only
#define unpackFromVar      227 //toVar=unpackFromVar(fromVar offset TEXT|OctetStr|NUMBER|NUMBER64|FLOAT [len]);//len is for text or OctetStr only
#define getUserByIndex     228 //var=getUserByIndex(Index);// index starts from 0,1,2...
//returns : var.0 - username, var.1=usertype (1=supervisor, 2=user), var.2=Encrypted password, var.3 - reserved,
//var.4 - groups separated by comma , var.5 - number of active webclients for this user
//var.6 - current IP Addreses this user connected from /comma separated/
#define addUser            229 //evfix445
#define deleteUserByIndex  230 //evfix445
#define ping               231 //evfix460
#define tableSetLine       232 // tableSetLine([/]id string[,ARRAY] {{-1|BorderColor},BackColor,FontBkColor,FontColor[,SelectedColor[:n]|-1]} [ADD[NH]|TITLE[NH]|INSERT|REPLACE[,NOUPDATE]] [i_line] [PLAIN|BOLD|ITALIC|BOLD+ITALIC[,FontPlusPixels]])
//If the line describes TITLE the colors correspond to the whole table parameters (BorderColor},BackColor)
//-1 used as   BorderColor in TITLE line means that the table does not have any border (transparent border)
#define tableGetLine       233 // var=tableGetLine([/]id [i_line])
#define tableClear         234 // tableClear([/]id);
#define tableSelectLine    235 // tableSelectLine([/]id [i_line])
#define tableDeleteLine    236 // tableDeleteLine([/]id [i_line])
#define tableChangeCell    237 // tableChangeCell([/]id[,user_defined_string] li_line i_cell {BorderColor,BackColor,FontBkColor,FontColor[,text|BUTTON_CELL[,textoffset|BUTTON_CELL]]} [height[,BMP_NAME[,bmpoffset]]] [NOUPDATE] [PLAIN|BOLD|ITALIC|BOLD+ITALIC[,FontPlusPixels]])
//note that the horizontal size of the BITMAP-cell is NOT defined by the size of the bitmap. It is defined by the size of the "text" when STANDARD font is used .
#define runScript          238 // runScript(var [THREAD] [LOCAL]) - runs batch file, which is built from var.0,var.1,var.2,.. ""
#define getMIBobject       239 // var=getMIBobject(mibobject);
#define startUDPServer     240 // startUDPServer(port descriptor_path|"STOP" [service_name]); e.g. startUDPServer(7 "@local\\udpcback" "sflow");//"STOP stops server

//the below two commands are usually issued in the udp server callback descriptor
#define getUDPRequest      241 // vararray=getUDPRequest([rport variptext]););//gives what UDP Server received in vararray.0,vararray.1 ...etc as needed length of var=512 byte is required
#define setUDPResponse     242 // setUDPResponse(varresp[,sourceport] [alt_ipaddresstext alt_dest_port]);//actually send response from the UDP Server. Client address and destination port can be changed to alternative.
//IMPORTANT: Note if you do not want to response set varresp=""; BUT YOU STILL HAVE TO ISSUE  setUDPResponse(varresp);  to free memory
//alt_ipaddresstext may be broadcast,  like "255.255.255.255";
//The sourceport is parameter will work only if startUDPServer(sourceport ... was  started on this port before in the same MV session
//The sourceport parameter can be set ONLY if the  setUDPResponse command is NOT issued from the callback descriptor (yes, it is possible to send "response" without receiving request before)
#define tableEditCell      243 // tableEditCell([/]id line_index cell_index [combovararray[,n_vars] | menuitem | STRONGNOTIFY]);//STRONGNOTIFY is only for edittext
#define dialPhoneNumber    244 // [reg|var]=dialPhoneNumber(phonestring,messagestring)
#define isMapAllowed       245 // isMapAllowed(mapname);  checks if 'mapname" can be accessed by the current user.
#define trimVarArray       246 // trimVarArray(vararray NewNumberOfElements); e.g. trimVarArray(myvar 5);//may be also used to free memory
#define addScheduler       247 // addSheduler(line [GLOBAL]); //see @local\tsched.dsc for explanations;//evfix1553: note there was a bug in 'hour', fixed starting v2.33m7
#define getSchedulerByName  248 //line=getSchedulerByName(SchedulerName [GLOBAL]);  //returns false if Index is wrong
#define getSchedulerByIndex 249 // line=getSchedulerByIndex(ShedulerIndex [GLOBAL]);// index=-1,0,1,2,3,4.... returns false if Index is wrong
//see @local\tsched.dsc ;getSchedulerByXXX returns line.0,1,2.....10 ; The last one is .10 which is nextActionTime (in seconds after 1 Jan 1970
//getSchedulerByIndex(-1), means return the "current scheduler: this can be issued from the descriptor which is IS CALLED by the CURRENT scheduler
#define delSchedulerByName  250 // delSchedulerByName(SchedulerName [GLOBAL]); //delete scheduler
#define setLedImage         251 //setLedImage(/controlId ledNumber BitmapName);
#define tableGetCell        252 //var=tableGetCell([/]id i_line i_cell) //line.0=BorderColor,line.1=BackColor,2=FontBkColor,3=FontColor,4=text,5=height,6=width,7=BMP_NAME,8=user_defined_string
#define setDropSource       253 // setDropSource(rangeOfidsOrItems); //setDropSource(/12>15,90)
#define saveMapInfo         254 //saveMapInfo([ALL]) - saves current map (no params) or ALL maps
#define tableOperation      255 //tableOperation(PRINT|ORDERBY,index,{INCR|DECR}|LOAD|SAVE|SAVETEXT[,CSV]|SAVETEXTWITHTITLE[,CSV]|UPDATE|CLEANEDIT [/]id [filename])
//tableOperation(ORDERBY,index,{INCR|DECR} [/]id); - sort table by lexicographic value of column=index
//When sorting, the cell-title for column=index will automatically indicate with "v" or "^" sufffixes. In order to clean the suffix in the title,
//use tableOperation(ORDERBY,-1,INCR /11); example in @local\devlist.dsc
#define getTL1Config        256 //getTL1Config(var);
#define setTL1Config        257 //setTL1Config(var);
#define tl1Answer           258 //tl1Answer(tid ctag payload); //evfix1007
#define writeFileLine       259 //writeFileLine(OPEN|OPENBIN|WRITE|NWRITE|WRITEBIN|CLOSE varFilePath|varline [filehandle_reg])
////if varline for "WRITE" operation ends with "\n&", it does not write, just adds varLine to the previousely collected buffer (to allow srings which are >512 length)
//example 1: Use when you need to write to only one TEXT file at a time /per descriptor/
//writeFileLine(OPEN  "@data\\myfile.txt"); writeFileLine(WRITE "line 1"); writeFileLine(WRITE "line 2"); writeFileLine(CLOSE "@data\\myfile.txt");
//example 2:  Use when you need to write to more than one TEXT file at a time /per descriptor/ or pass file handle to another descriptor
//writeFileLine(OPEN  "@data\\myfile.txt" reghandle); writeFileLine(WRITE "line 1" reghandle); writeFileLine(WRITE "line 2" reghandle); writeFileLine(CLOSE "@data\\myfile.txt" reghandle);
//example 3: Use when you need to write to only one BINARY file at a time /per descriptor/
//writeFileLine(OPENBIN  "@data\\myfile.bin"); writeFileLine(WRITEBIN octestrvar.0); writeFileLine(WRITEBIN octestrvar.1); writeFileLine(CLOSE "@data\\myfile.bin");
//example 4:  Use when you need to write to more than one BINARY file at a time /per descriptor/ or pass file handle to another descriptor
//writeFileLine(OPENBIN  "@data\\myfile.bin" reghandle); writeFileLine(WRITEBIN octestrvar.0 reghandle); writeFileLine(WRITEBIN octestrvar.1 reghandle); writeFileLine(CLOSE "@data\\myfile.bin"  reghandle);
//NWRITE by defualt WRITE terminates the line with "\r\n"; If you do not want this termination, use NWRITE instead of WRITE
#define sendHttpRequest     260 //n_respvars=sendHttpRequest(varreqresp hostnameip [uri [[["GET"|"POST"] headers] port]])
#define xmlError            261 //evfix1100
#define xmlAnswer           262 //evfix1100
#define openRs232           263 //handle=openRs232(baudrate portname);//evfix1102  returns false if error
#define closeRs232          264 //closeRs232(handle);//evfix1102
#define sendRs232           265 //n_respvars=sendRs232(varreqresp {WRITEREAD|WRITE|READ} handle); //evfix1102
#define openEther           266 //openEther(); //evfix1103  
#define getEtherAdapters    267 //n=getEtherAdapters(adapters);//evfix1103
#define selectEther         268 //selectEther(AdapterNumber);//evfix1103  
#define sendEther           269 //sendEther(varreqresp WRITE);//evfix1103  
#define closeEther          270 //closeEther();//evfix1103  
#define setAlarmDesc        271 //setAlarmDesc(GENERIC|SPECIFIC Number DescriptorPath|No [RUNTIME]);//see index# in *.alr
//Note that using setAlarmDesc will NOT allow placing the regular alarm message in the log and it is descriptor developer responsibility
//to place in the log wthever should be placed). If you do not like this and still want regular processing, use SYSALRACTS... or SYSALRACTG...
//device parameters instead, , e.g.
//setDeviceParam("SYSALRACTS5" "@mydirname\\mydescr.dsc" STR); assign action descriptor "@mydirname\\mydescr.dsc" to specific alarm with index "5"
//the above will call mydesc.dsc BEFORE the corresponding alarm msg comes to the log
#define pauseExecution      272 //pauseExecution(nSec); wait nSec,better alternative to "wait" method. 
//pauseExecution(0) should be used between many  "un-interruptive" operations (inside loops) to let other descriptors/users work
#define openTcp             273 //handle=openTcp(port [iptext [timeout [NOSSL|SSLTELNET|SSL]]]);
#define sendTcp             274 //n_respvars=sendTcp(varreqresp {WRITEREAD|WRITE|READ} handle [timeout [expectbytes [expect1 [expect2]] ]]);
//varreqresp.0 varreqresp.1  .... varreqresp.n=""; //request
//reg=="" do not send anything, just receive
#define closeTcp            275 //closeTcp(handle);//evfix1150
#define setItemObj          276 //setItemObj(Item ^var|"*"); //^var is a result of getMIBobject
#define getSlotPos          277 //line=getSlotPos([/]control [WEBEXACT]) //returns in line: x,y,width,height
//WEBEXACT means in web mode go and get exact sizes (in case user resized it) - this is for backward compatibility, because it was not the case before)
#define startWaitWin        278 //startWaitWin([NOBITMAP]);
#define setWaitWinText	    279 //setWaitWinText(text);
#define endWaitWin          280 //endWaitWin();
#define tftpStart           281 //evfix1244
//reghandle=tftpStart("SERVER" serverdir WAITWIN|Click32763  [serverport [timeout retries]]);
//reghandle=tftpStart("CLIENT" serverip  WAITWIN|Click32763  "SEND"|"RECEIVE" localfile remotefile [serverport [timeout retries]]);
//defaults: port=69  timeout=3 (sec) retries=7;
//Comments: WAITWIN|Click32763  tells how to report progress: via WAITWIN or doWhen(CLICK /32763) ; $0
//For SERVER: End of operation will be reported via Click32763 anyway  see example in @local\tftp.dsc
#define tftpStop            282 //tftpStop(handle) ;//evfix1244
#define tftpGetBytesResult  283 //nbytes=tftpGetBytes(handle result); //get n_copiedbytes and/or result/report of  TFTP operation
#define addMenu             284 //addMenu(menufile); e.g addMenu("@mcc\\mcc");  //evfix1259
#define tableGetSelection   285 //tableGetSelection([/]id RegLine RegCell) //evfix1261
//important: because TITLE line(s) can never be selected one, tableGetSelection will never return title as selected LINE!
//therefore never use line,cell returned by tableGetSelection to check if user clicked on title line. Use:
//Use something like if(SelectedLine<=0) for this purpose.  
#define getMicrosoftPCs     286 //var=getMicrosoftPCs(pcnumber);//pcnumber=0,1,2,3,4...
#define copyOneFile         287 //copyOneFile(SourceFile DestFile [OVERWRITE|RENAME]) ;//returns true if success, false otherwise
//Note that you do not have to worry about Linux/Unix dir delimeter here 
#define getDeviceStats      288 //var=getDeviceStats();//evfix1354
//var=0 minRespTime(ms),1 maxRespTime(ms),2 aveRespTime(ms),
//3 lastSendTimestamp(sec),4 lastSendTimestamp(ms portion),5 lastRespTimestamp(sec),6 lastRespTimestamp(ms portion);
//7 lastStopTimestamp(esc),8 lastStopTimestamp(ms portion), 9 availability in %  , 10-startTime
#define snmpSendVars        289 //varsresp=snmpSendVars(regtype  vars);//regtype GET=1,NEXT=2,RESP=3,SET=4,TRAP=5,SQUE=6,INFORM=7
#define snmpProxyResponse   290 //snmpProxyResponse(reqid ppp reqtype varsresp);
#define snmpProxyTimeout    291 //snmpProxyTimeout(ppp);
#define getIfStats          292 //ifline=getIfStats(ifnumber);//evfix1402 ifnumber=0,1,2,3,4...;ifline structure is the same as for getIfStatsByInd
#define getUserGroups       293 //line=getUserGroups([username]); //without username returns all groups, otherwise just groups for the user
#define addUserToGroup      294 //addUserToGroup(username groupname); //adding to group "None" removes from all groups
#define getVarType          295 //reg=getVarType(var); 2=INTEGER, 4=TEXT, 5=OCTSTRING  PhysAddr=7, IPADDR=64 ,IPADDR=1 | COUNTER=65 | GAUGE=66 | DOUBLE=73 | BIT_STR=3
//COUNTER64=70,INTEGER64=74,UNSIGNED64=75,FLOAT=72(seldom,use DOUBLE),OPAQUE=68,TIMETICKS=67
#define snmpSetErrorVar     296 //snmpSetErrorVar(var error_code [error_string]);//set error_code in var for agent snmp response.
#define checkUserPassword   297 //checkUserPassword(UserName Password);
#define openCli             298 //handle=openCli(appstring varresp[,CRLF]  [timeout [expect1 [expect2]]]);//opens and gives the first prompt in varresp
//for SSH in Win32 appstring is 
//"c:\lanw\data\apps\plink.exe" -ssh -P 22 -l UserName -pw PassWord 192.168.1.10
//for SSH in Java (both Windows and Unix) appstring is 
//ssh -P 22 -l UserName -pw PassWord 192.168.1.10
//CRLF means: include '\r' and '\n' in response - by defult they are excluded
#define sendCli             299 //handle=sendCli(handle    varreqresp  [timeout [expect1 [expect2]]]);
#define closeCli	        300 //closeCli(handle);
#define getUserParam        301 //parvalvar=getUserParam(username parnamestring [RUNTIME]);
#define setUserParam        302 //setUserParam(username parnamestring  parvaluestring [DELETE|NoSave|RUNTIME] [NoSave|RUNTIME])
// for DELETE if parnamestring ends with * , delete all with the corresponding prefix
// example 1: setUserParam(username.0  MYFEATURE*    "notimportant" DELETE);
// example 2: setUserParam(username.0  "MYFEATURE*"  "notimportant" DELETE NoSave);
#define getGroupInfo        303 //var=getGroupInfo([groupname])  var.0=usersvar var.1=0|1 (group enable status)
#define writeToWebPage      304 //writeToWebPage(String);//evfix1564
#define getWebClientInfo    305 //var=getWebClientInfo();/returns: var.0=sec,var.1=urliptext,var.2=serverport,var.3=mprnumb,var.4=ipstring
#define getUserByName       306 //var=getUserByName(username);   return is the same as in getUserByIndex
#define setVarType          307 //setVarType(type var);//type: 2=INTEGER, 4=TEXT, 5=OCTSTRING  PhysAddr=7, IPADDR=64 ,IPADDR=1 | COUNTER=65  BIT_STR=3
#define addNewDevType       308	//addNewDevType(typename typecomment);
#define compareStringTo     309 //  retvar|retreg=compareStringTo(teststring pattern [Ignore] [Trim]);");//pattern may contain wildcard '*' and/or '?'
//returns: ret=0  - the strings are equal (considering '*'/'?' if it is part of pattern), returns "true"
//         ret=-1 - the teststring is less than lookforstring lexicographically, returns "false" (no wildcards)
//         ret=1  - the teststring is greater than lookforstring lexicographically , returns "false" (no wildcards)
//"Ignore" means "Ignore Case"; "Trim" means "Trim leading and ending whitespaces from both teststring and patern before comparing"
//this function can also be used for bitwise operatons on octetstring data types (like TEXT,OCTETSTR, PhysAddr,OPAQUE,BIT_STR  ....)
//retvar=compareStringTo(stringvar1 {stringvar2|~}  &|||^);
//example 1. bitwise AND :   retvar=compareStringTo(stringvar1 stringvar2  &);
//example 2. bitwise OR  :   retvar=compareStringTo(stringvar1 stringvar2  |);
//example 3. bitwise XOR :   retvar=compareStringTo(stringvar1 stringvar2  ^);//exclusive OR
//example 4. bitwise NOT :   retvar=compareStringTo(stringvar1 ~);//unary operation: "logical complement";
#define setAppParam         310 //setAppParam(parname [parvalue|DELETE] [INTEGER|STR|BYTES|FLOAT|RUNTIME] [NoSave]);//the same format as setDeviceParam
// for DELETE if parname ends with * , delete all with the corresponding prefix
// example: setAppParam("MYFEATURE*" DELETE RUNTIME);
#define getAppParam         311	//getAppParam(param-name parvaluevar [INTEGER|STR|BYTES|FLOAT|RUNTIME]);//the same format as getDeviceParam
#define mathFunction        312 //resultvar=mathFunction(SQRT|ABS|POW|MOD|EXP|RAND  vararg1 [vararg2]); //resultvar type is the same as the tyoe of vararg1 ;
#define setResizing         313 //setResizing(YES|NO); //evfix1620
#define getWebFormParam     314 //parvalue=getWebFormParam(parname); If no value returns false  evfix1624
#define writeWebPageItem    315 //writeWebPageItem(items)
#define getIfStatsByInd     316 //ifline=getIfStatsByInd(If1 if2 if3 ....);//normally just one parameter which corresponds to interface index
//ifline structure is the same as for getIfStats:
//0- ifdescription string, 1 -ifindex as a string,2- Current status, Integer //up(1) down(0) unknown(-1),3- lastSendTimestamp seconds after 1970
//4- lastSendTimestamp milliseconds portion,5 - last time it was OK  seconds after 1970,6 last time OK milliseconds portions,
//7- last time went down seconds after 1970; 8-last time went down milliseconds portion,
//9- Availability in %,10- StartTime of monitoring this if in sec after 1970,11 Down time in seconds
//12 interface sequential number 0,1,2,3... this is not ifindex
//13,14,15,16,17,18: double minBitsPerSec,maxBitsPerSec,avrBitsPerSes; minErrPerSec,maxErrPerSec,avrErrPerSec;
//19: last time  performance updated (in seconds  after 1970);//20 Bandwidth  speed in units of 1,000,000 bits per second. 64-var
//21 Utilization in % of Bandwidth FLOAT var;//22 userstring;//23 Integer=artifitial interface, If Yes=1 if not=0;//evfix2601
//24,25 double curBitsPerSec, double curErrPerSec; if not updated yet, it is -1
#define setIfStats          317 //calll it update/create interface/tree info, can be used also to REMOVE
//New: setIfStats(i1,i2,i3... {linkStatus,[userstring]|REMOVE} [description[,ART] [inBytes outBytes inErr outErr bandwidth]]); inBytes,outBytes - counters64, inErr,outErr->numbers
//bandwidth  - counters64 ///linkStatus=up(1),down(2),testing(3) like in mib-2 
// ART - artifitial interface , tells to engine: do not POLL, do not delete
#define getAppService       318 //servvar=getAppService(ServIndex|ServName);//index=0,1,2,3... Returns false if there are no more services/or
// no service with such name. servvar.0=service_name,servar.1=serv_description,servvar.2=serv descriptor like "@extdir\\servwin.dsc:DLG_SERVWIN"
//servvar.3=app specific service parameter, servpar.4=Status (0-5). servpar.5=0|1 (donotmonitor)
//servvar.6=pollinterval (if 0 - do not poll) servvar.7=service polling descriptor like "@extdir\\servpoll.dsc".
//servpar.8=User/Or group of users associated with this service, if if group should be "GROUP:group name" can be empty "";
//servpar.9=service DELETE descriptor like "@ethserv\\ethdelserv.dsc", or (if not set) "" - empty string
//10- last time checked in  seconds after 1970 11- last time checked milliseconds portion,
//12- last time service was OK in  seconds after 1970; 13- last time was OK milliseconds portion,
//14- last time went down in seconds after 1970; 15-last time went down milliseconds portion,
//16 Availability in %,17-StartTime of monitoring this if in sec after 1970,18-Down time in seconds
//All the params are optional except service_name; rervvar.0)
#define setAppService       319 //setAppService(servvar [DELETE|NoSave] [NoSave]);//servvar.0=service_name,servvar.1=serv_description,
//servvar.2=serv descriptor like "@ims\\servwin.dsc:DLG_SERVWIN" servvar.3=app specific service parameter .
//servpar.4=Status (0-5). servpar.5=0|1 (donotmonitor) servvar.6=pollinterval (if 0 - do not poll) servvar.7=service polling descriptor like "@ims\\servpoll.dsc".
//servpar.8=User/Or group of users associated with this service, if if group should be "GROUP:group name" can be empty "";
//servpar.9=service DELETE descriptor like "@ethserv\\ethdelserv".
//servpar.19, if servpar.19==1 reset statistics for this service;// use only with NoSave to reset
// All the params are optional except service_name; servvar.0)
//Note: deleteing service automatically deletes it from all the links
#define smoothData          320 //smoothData(xmin xmax nxdel vx vy n_values [ymin ymax]);//smoothing data for graphs
//xmin , xmax - output parameters; vx,vy,n_values - both input and output parameters; 
// nxdel - input parameter, usually=60 - the desired number of "smoothed" points;//see @local\\ifmonlst.dsc  
#define isAlNumString	    321 //evfix2003 isAlNumString(^var [maxlength]);
//returns true only if the string contains digits and numbers and '-' and '_'  . Checks for maxlength if this parameter is used
#define getDscWinByIndex    322 //winline=getDscWinByIndex(Index); //returns false if index>=number of windows , returns var.0 - var.6;
//winline=dscname(0),dialog/full dsc(1),device name(2), devtype name(3) WebClientIP/"local"(4) username(5) , mprtnumb (6)
#define getDirContents      323 //n=getDirContents(Directory files); //returns array of names(files) which are in the directory, 
//directory maybe strat from "@" (or not) //files.0, file.1,.....file.(n-1) //the size n is returned as a returned code
//also returns 'false' if something went wrong
#define getFileAttributes   324 //fline=getFileAttributes(FilePath) // file path can start from "@" (or not); returns array of files attributes
//fline.0 =short name, like :read.me";  fline.1= FileFlag (0=directory, 1=file) fline.2  last modified in seconds after Jan 1st 1970
//fline.3  size in bytes . fline.4 - full file path ; fline.5 - directory which contains the file (with last dir delimeter in the end)
//returns "false" if file/directory does not exist at all
#define getVarMIBobject     325 //getVarMIBobject(var i_mibreg i_objreg);//first parameter is a source var 
//two last parameters are registers to receive output values i_mib and i_obj
#define treeCreate          326 //treeCreate([/]id BackColor)	
//for tree example see @local\testtree.dsc , GUI access: debug menu->TestTreeAndSplitter
#define treeSetNode         327 //handle=treeSetNode([/]id parenthandle,{ADD|INSERT,xx|REPLACE,xx}  textstring[,user defined string] [image_name_string])
//note that optional "user defined string" can keep anything you want
//xx - is zero-based index of this node in this node parent's list of children,see line.6 in treeGetNode
#define treeDelNode         328 //treeDelNode([/]id [handle]);//if handle parameter is absent, all the nodes are deleted
#define treeGetNode         329 //line=treeGetNode([/]id [handle]);//if no second parameter returns selected node
////returns: line.0=name , line.1 - bitmap , line.2 - n_children ,line.3 - handle ,line.4 - tooltip,line.5 - user defined string (if any) , line.6 - child-index in the parent (0,1,2,3...)
#define treeSelectNode      330 //treeSelectNode([/]id handle [EXPAND|COLLAPSE])
#define setSplitControl     331 //setSplitControl([/]id HOR|VER ALL|PART);
//set control id to be a slider-splitter (which can be "dragged" either verically(VER : up<->down ) or horizonally(HOR: left<->right)).
//This means that user will be able to move(drag) this splitter-control to increase/decrease size of controls which belong to left/right/upper/down side
//of this window.  ALL|PART= ALL - resize/move all the controls correspondingly; PART - resize/move only thouse controls which are located on the same
//level with the slider-splitter control - this allows to create windows divided by two spliters: HOR and VER; see mcc application main window
//for simple vertical splitter see @gen\gen.dsc - main window of generic SNMP device
//also see @local\testtree.dsc for examples , GUI access: debug menu->TestTreeAndSplitter
#define setActiveTab        332 //setActiveTab(tabindex);//tabindex=0,1,2....  For Tabbed windows, can be issued from Tab creators only
#define pictureSet          333 //pictureSet([/]id[,SCROLL|NOSCROLL] {BorderColor BackColor [BackImage]}|CLEAR|UPDATE);
#define pictureElementSet   334 //[reg=]pictureElementSet([/]id[,user defined string]  {ADD|CHANGE:index|INSERT:index|REMOVE:index} x1,y1[,BUTTON_CELL] {LINE:{SOLID|DASH|DOT}:x2,y2:linewidth|IMAGE:imagename|TEXT:text:{PLAIN|BOLD|ITALIC|BOLD+ITALIC}[,FontPlusPixels]} [Color[,BackColor[,BorderColor]]] [NOUPDATE]);
//examples: 
// pictureElementSet(/12 ADD 10,4   LINE:SOLID:150,60:3 GREEN,LGRAY);//width=3
// pictureElementSet(/12 ADD 150,60 LINE:SOLID:190,40:3 RED,LGRAY);//width=3
// temp.0="some text"
// pictureElementSet(/12 ADD 290,60,BUTTON_CELL TEXT:temp.0:BOLD,3    WHITE,BLUE,RED);//add gtext which looks like button
//pictureElementSet(/11  ADD 25,30  IMAGE:"BMP_GOOD"  NOUPDATE);//add image BMP_GOOD at (25,30)
//returns index of added/modified pictureElement
#define concatStrings       335 //varres=concatStrings(string1 string2 string3 .......);//evfix2191 this finally allows building strings in one statement without reassignment
// like var.0=concatString(var.0 var.1); something like var.0=var.0+var.1
#define appendFile          336 //appendFile(filepath string); e.g: appendFile("@data\\myfile.txt" var.0);
#define setStartupDesc      337 //setStartupDesc(desc_path[:DIALOGNAME]  [DELETE]);//example:setStartupDesc("@sflow\\sflowini");  setStartupDesc("@sflow\\sflowdlg:DLG_SFLOWDLG");
#define replaceWord         338 //replaceWord(stringvar wordtolook  wordtoreplacewith  [Ignore])");
#define showWebPage         339 //showWebPage([/]id urlstring|BACK|{GRAPH,graphpars}|{PHP,phppars} [DISABLESCRIPTS]);//shows Web Page embedded in control OR PHP Graph or PHP Page(button) 
//for "GRAPH":pars.0="pie";  //pars.1="'alpha','beta','gamma','delta'" (names comma separated); pars.2="10,20,30,40"; (values comma separated)
//for "PHP"  :pars.0= phpscriptstring. if phpscriptstring ends with "\n&", it does not perform the request, just puts in buffer. pars.1="@data\\scripts\\php\\" - working ends with "\\"" 
//see examples in @data\local\testfoc.dsc ; GUI called via: option->login->debugging->menu->Focus Test
//PHP should not be used in MVJ embedded	
#define getWebPageUrl       340 //var=getWebPageUrl([/]id);
#define pictureElementGet   341 //line=pictureElementSet([/]id index);//index=0,1,2,3...
//returns in line.0 - userstring (if any) ; in line.1 - textstring/bmpname (if any) ; line.2 - tooltips if(any)
#define copyVarArray        342 // copyVarArray(dstvararray[,dstoffset] {sourcevararray[,sourceoffset]|CONSTANT} [offset [number_of_elem]]);
//CONSTANT may be integer, like 0   or it may be string in quotes, like "some text". When constant is set, all the aray vars get value which equals to CONSTANT
//if dstoffset/srcoffset are not indicated, assuming dtsoffset/srcoffset=0
//if any of dstoffset,srcoffset,offset are not indicated assuming dtsoffset/srcoffset/offset=0;  
//if dstoffset/srcoffset and offset are indicated , the final offset in dst/src will be : (dstoffset+offset)/(srcoffset+offset)
//if number_of_elem is not  indicated - assuming "till the end of sourcevararray"