// define globals variables

// --- Numbers ----

#define NumberOfSymbols 1  // number of device types in "devices.all"
#define NumberOfDevices 2  // number of devices defined in this map
#define NumberOfCards   3  // number of cards in the "device.crd" file; no! it is actualy number of slots
#define NumberOfSlots   4  // number of slots for this device (devices.all)
#define DeviceNumType   5  // device type (in devices.all)
#define DeviceVersion   6  // device version number (default=0)

#define CardType        7  // the current card's type (if we inside a card)
#define NumberOfPorts   8  // the number of ports for the current card.
#define slot#           9  // the current card's slot (start from 1)
#define DescVersion    10  // the Descripror's version#
#define UserType       11  // Current user access type 1=supervisor, 2=user
#define MenuItem       12  // "command#" of the menu-item (from *.mnu)
#define AddressType    13  // Address from *.ini. 1=IP, 2=IPX, 3=both
#define isWindowOpen   14  // is this window is open (or only from polling)
#define pointedLed     15  // the number of the last- pointed led (-1 if none).
#define errorType      16  // last error from agent
#define errorIndex     17  // last error-index from agent
#define queueSize      18  // number of "vars" (changes) in queue

#define device#        19  // the device-index selected for this window
#define clickId        20  // id of clicked

#define commOK         21  //=0|n SNMP communication status as it is reported by engine backround
//polling, SNMP communication status=0|n .
//commOK is either 0 (no SNMP communication) or not 0 (SNMP communication is OK)
//if SNMP communications is OK, n is returned, where n=1,2,3... which is number of "Describe" IP
//Interface which carries the SNMP communication, see Describe dialog 
//Now you can also set commOK ; 0- no ocmmunication, 1,2,3... communication via SNMP Interfaces usually=1 commOK=1
// like INITASREADY in addParDevice//vfix2562 
#define moniInterval   22  // The window's monitor interval (can be set)
#define pollInterval   23  // The device's polling interval (can be set)
#define NumbOfInterf   24 //Number of interfaces
#define selfIPAddrNumb 25 //evfix2 SelfIP number: USING: tmp=selfIPAddrNumb;// ItemName=tmp;
#define nmsTime        26 //local time in seconds  since 00:00:00 on  January 1, 1970 (i.e. epoch)
#define Retries        27 //evfix4 retries number
#define TimeOut        28 //evfix4 TimeOut in sec.
#define platform       29 //platform=0 (0=StandAlone,1=Configurator,2=embedded or WebNMS)
#define WebFlag        30 //evfix75
#define Win32          31 //evfix92
#define Configurator   32 //evfix217
#define SelectedLine   33 //evfix210
#define SelectedCell   34 //evfix210
#define DroppedId      35 //evfix861
#define JavaFlag       36 //returns 1 for mvj,0 in other cases// evfix1125
#define lastWindowSendTime   37 //time of last SNMP send (try) in seconds , (per window .when window tried to send)!
//(includes send(GET|SET|NEXT|SQUE|GQUE..,.getQueue,sendQueue,putInQueue) //evfix1199
//note that if the window is dialogless in doWhen(OPEN) event, the parent is also updated
#define show_software_errors 38 //see lan4.ini file returns 1, if Dev Env, otherwise - 0
#define goodSnmpSetsCounter  39 //'DirtyBit' per Device: number of sucssesful //evfix1229
//SNMP sets, can be assigned value as well//evfix1229
#define EmbedFlag              40 //Java only //evfix1604
#define DeviceDescriptorStatus 41 //evfix1771 can be set from descriptor for the devices which are not background
//polled, cleared by clearAlarms
#define altSnmpPort    42//evfix1712 alternative snmp port for current window and all it's child windows, do not use "999" value
#define isClone        43//evfix2001 returns 0 or !=0 (!=0 - if device is a Web Mode Clone created to help showing the same
#define isPage         44//evfix2129 is page/tab in the sheet
#define sysSQLflag     45//0-not installed, 1- MSDE, 2-SSE 3->MySQL, 4-SQLite 5->postgreSQL//evfix2170
#define sysProxyIndex  46//if(sysProxyIndex>=0) means device is managed via proxy //evfix2243
// dev front panel for two web clients)
#define sysJavaLook    47 //0-Java; 1-Native, 2- Motif
#define sysServiceFlag 48 //0 running regular, 1//running as service on windows (daemon without GUI on Linux/Unix)
#define nmsTimeUTC     49 //UTC time in seconds  since 00:00:00 on  January 1, 1970 (i.e. epoch)//evfix2610
#define WebNMS         50 // 0 normal, 1 - running under webnms as an EMS (MVJ only)


// --- Strings -----

#define DeviceStrType   1  // Current Device type name , see device.all
#define DeviceName      2  // Current Device name
#define DialogName      3  // name of this dialog window
#define CardName        4  // name of this card (if we are inside a card-dlg)
#define DescName        5  // name of this descriptor
#define pointedLedHelp  6  // the help of the last pointed "led"
#define ipAddress       7  // The device's ipAddress  in text format
#define OEMstring       8  // OEMstring
#define DeviceNote      9  // The device's Notepad

// Integration
#define enterpriseId   10  // the device enterprise id (from device.ini file)
#define currentTime    11  // system current time octet-string dd/mm/yy hh:mm:ss
#define appName        12  // name of this application
#define mapName        13  // name of current map
#define selfIpAddress  14  // evfix1 Evgeniy SelfIPAddress
#define getComm        15  // GET Community String for SNMPv1/v2 for 'current' device
#define setComm        16  // SET Community String for SNMPv1/v2 for 'current' device
#define DeviceMapName  17  // Name of the Map which contains Current Device 
#define CurWebAlarm    18  //evfix360
#define UserName       19  // Current User Name e
#define PCInfo         20  //CODED PC INFO evfix515
#define selfMACAddress 21  //self MAC evfix515
#define VersionString     22 //VersionString, like v2.29k evfix1248
#define VersionDateString 23 //Date, like June/12/2005   //evfix1248
#define snmpEngineId      24 //SNMPv3 snmpEngineId ,Text String //evfix1383
#define UserGroups        25 //evfix1346
#define externalParameter 26 //evix1525
#define SubVersionString  27 //"Configurator" "Pro" "Enterprise" //evfix1548
#define sysWinParameter   28 //now it can be used when sendClick sends parameter to another window //evfix2520
#define sysDirDelimeter   29 //evfix2029 "\\" (windows) or "/" - Linux/Unix
#define sysSelfHostName   30 //evfix2259 
#define cloneSrcDevName   31 //if this device is web mode clone returns the source device name, if not it is the same as DeviceName
#define DevParentStrType  32 //The same is DeviceStrType but parent for example: CMMC is a  parent of NC316 device
#define sysDevBrotherDev  33 //allows to use brother device descriptors (with some limitations connected to globals) //evfix2526

// --- leds types (in files *.led) ---

#define LED    1
#define TEXT   2
#define NAME   3
#define BMP    4
#define FONT   5
#define PEN    6
#define LINE   7
#define MNU    8
#define HOTS   9  // hot-spot
#define MATRIX 10 // Integration - fix19
#define CTEXT  11 //evfix73


// --- sim  types (in files *.sim) ---

#define FIXED  1
#define INDEX  2
#define LIST   3
#define RANGE  4
#define TIME   5

// ----  items types  (for #declare ITMS) ------

#define DUMMY        1   // for internal use only
#define TEXT         vt  // Show text as it is
#define COMBO        vj  // Select text in Combo-Box (selction Menu)
#define RADIO        vr  // Select Radio-Button (from number)
#define MENU         vm  // Show text from menu-items (from number)
#define INDEX        ii  // Get index from list-box
#define CHECK        vc  // Check/Uncheck Check-Box
#define MenuRadio    vg  // Select Radio-Button (string from menu)
#define NUMBER       vl  // Show formated number number (default=%lu")
#define ObjectID     vo  // Show Long numbers as ObjectID (dot notation).
#define IPXaddr      vx  // Show octet string as IPX address
#define MACaddr      va  // Show octet string as MAC address
#define IPaddr       vp  // Show long number (IP type) as IP address
#define ANYaddr      vh  // Show number as IP,IPX,MAC according to type and length
#define BitsMask     vb  // Show octet string as bits (see User Manual for options)
#define OctetStr     vz  // Show octet string as formated numbers (default=%02d:);
#define MarkedIndex  kk  // The index in the list box is marked inside []
#define Devices      vd  // Show device list in a menu/combo-box
#define CheckBytes   vcb // Show check-boxes as octet-string : 0,1,..

#define FLOAT        vf  // Show formated float number (default format=%lf")//evfix315
#define NUMBER64     v64 // Show formated 64t number (default= unsigbed?)//evfix315
//evfix315 for  NUMBER64: possible values of format "%u" unsigned "%l" -signed

// Integration
#define CheckIndexes vci // Show check-boxes as octet-string : indexes 1,3,5...
#define CheckBits    vcx // Show check-boxes as bits, if format=> then reverse
#define CheckMenu    vmx // Get/Save check-boxes as menu
#define ScrollBar    sn  // ScrollBar with edit/static number/menu
#define DayTime      vy  // Show Date and Time dd/mm/yy hh:mm:ss
#define Indexes      mk  // The new MarkedIndex

#define Groups       vzg  // show a octet-string as a group of numbers fix17
//evfix2582 variable type mostly like SNMP, but thre are some differences
//returns of reg=getVarType(var); 2=INTEGER, 4=TEXT, 5=OCTSTRING  PhysAddr=7, IPADDR=64 ,IPADDR=1 | COUNTER=65 | GAUGE=66 | DOUBLE=73 | BIT_STR=3
//#define SYSVARTYPE_IP          1
//#define SYSVARTYPE_INTEGER     2
//#define SYSVARTYPE_BITSTR      3 
//#define SYSVARTYPE_TEXT        4
//#define SYSVARTYPE_OCTSTR      5
//#define SYSVARTYPE_OBJID       6
//#define SYSVARTYPE_PHYSADDR    7
//#define SYSVARTYPE_IPADDR     64
//#define SYSVARTYPE_COUNTER    65
//#define SYSVARTYPE_GAUGE      66
//#define SYSVARTYPE_TIMETICKS  67
//#define	SYSVARTYPE_OPAQUE	  68
//#define SYSVARTYPE_COUNTER64  70 // (ASN_APPLICATION | 6)
//#define SYSVARTYPE_FLOAT      72 // (ASN_APPLICATION | 8)
//#define SYSVARTYPE_DOUBLE     73 // (ASN_APPLICATION | 9)
//#define SYSVARTYPE_INTEGER64  74 // (ASN_APPLICATION | 10)
//#define SYSVARTYPE_UNSIGNED64 75 // (ASN_APPLICATION | 11)
